﻿package jp.tonbi.controls
{
import flash.text.TextField;
import flash.events.MouseEvent;
import flash.display.MovieClip;

// 
[IconFile( "NavigationButton.png" )]
public class NavigationButton extends MovieClip {
	// フレーム移動のタイプ
	public const FIRST:String = "first";
	public const PREV:String = "prev";
	public const NEXT:String = "next";
	public const LAST:String = "last";
	public const PLAY:String = "play";
	public const STOP:String = "stop";
	private var __type:String = NEXT;

	// フレーム移動位置
	public const ROOT:String = "root";
	public const PARENT:String = "parent";
	public const CURRENT:String = "current";

	private const DISABLE:String = "disable";
	public var label_txt:TextField;
	
	// 使用できるか
	private var __enabled:Boolean = true;

	public function NavigationButton() {
		label = "次へ";
		enabled = true;
	}
	function mouseHandler( e:MouseEvent ):void  {
		gotoAndStop( __type + ":" + e.type );
	}
	function clickHandler( e:MouseEvent ):void  {
		var targetMc:MovieClip;
		
		switch ( level ) {
		case ROOT :
			targetMc = MovieClip( root );
			break;
		case PARENT :
			if ( parent.parent == stage ) {
				targetMc = MovieClip( root );
			} else {
				targetMc = MovieClip( parent.parent );
			}
			break;
		default :
			targetMc = MovieClip( parent );
		}
		switch ( __type ) {
		case FIRST :
			targetMc.gotoAndStop( 1 );
			break;
		case PREV :
			targetMc.prevFrame();
			break;
		case NEXT :
			targetMc.nextFrame();
			break;
		case LAST :
			targetMc.gotoAndStop( targetMc.totalFrames );
			break;
		case STOP :
			targetMc.nextFrame();
			break;
		default :
			targetMc.gotoAndStop( label_txt.text );
		}
	}

	[Inspectable( enumeration="root,parent,current", defaultValue = "current" )]
	public var level:String = "current";

	[Inspectable( defaultValue = "次へ" )]
	public function set label( str:String ):void {
		label_txt.text = str;
	}
	public function get label():String {
		return label_txt.text;
	}

	[Inspectable( defaultValue = true )]
	public override function set enabled( b:Boolean ):void {
		__enabled = b;
		buttonMode = b;
		if ( b ) {
			gotoAndStop( __type + ":" + MouseEvent.MOUSE_OUT );
			addEventListener( MouseEvent.MOUSE_OVER, mouseHandler );
			addEventListener( MouseEvent.MOUSE_OVER, mouseHandler );
			addEventListener( MouseEvent.MOUSE_OUT, mouseHandler );
			addEventListener( MouseEvent.MOUSE_DOWN, mouseHandler );
			addEventListener( MouseEvent.MOUSE_UP, mouseHandler );
			addEventListener( MouseEvent.CLICK, clickHandler );
		} else {
			gotoAndStop( __type + ":" + DISABLE );
			removeEventListener( MouseEvent.MOUSE_OVER, mouseHandler );
			removeEventListener( MouseEvent.MOUSE_OUT, mouseHandler );
			removeEventListener( MouseEvent.MOUSE_DOWN, mouseHandler );
			removeEventListener( MouseEvent.MOUSE_UP, mouseHandler );
			removeEventListener( MouseEvent.CLICK, clickHandler );
		}
	}
	public override function get enabled():Boolean {
		return __enabled;
	}

	[Inspectable( enumeration="first,prev,next,last,play,stop", defaultValue="next" )]
	public function set type( _str:String ):void {
		__type = _str;
		if ( __enabled ) {
			gotoAndStop( __type + ":" + MouseEvent.MOUSE_OUT );
		} else {
			gotoAndStop( __type + ":" + DISABLE );
		}
	}
	public function get type():String {
		return __type;
	}
}
}